/***************************************************************/
//
//
//		DirectX	[ debugmanager.cpp ]
//
//											Author	kazuki tanaka
//											Date	2017 1/7
/*---------------------------------------------------------------
Update : 2017/1/7
			debugmanager.cpp̍쐬

/*---------------------------------------------------------------
	CN[ht@C
---------------------------------------------------------------*/

//#include <Windows.h>
//#include <stdio.h>
//#include <d3dx9.h>

//#include <WinBase.h>
#include "main.h"
#include <stdlib.h>
#include "object.h"

// vZR|[lg
#include "game_equation.h"

//#pragma comment (lib,"d3d9.lib")
//#pragma comment (lib,"d3dx9.lib")
//#pragma comment (lib,"dxguid.lib")

using namespace std;      								// WCuOԎw

/*---------------------------------------------------------------
	}N`
---------------------------------------------------------------*/

#define SAFE_RELEASE(p) { if (p) { (p)->Release(); (p)=NULL; } }
#define RADIAN( theta ) ((( theta ) * D3DX_PI ) / 180 )	// WApւ̕ϊ

// AtBϊ
#define AFFINE_TRANSFORM_X( radiusX, radiusY, theta ) \
(( radiusX ) * cosf( RADIAN( theta )) - ( radiusY ) * sinf( RADIAN( theta )))

#define AFFINE_TRANSFORM_Y( radiusX, radiusY, theta ) \
(( radiusX ) * sinf( RADIAN( theta )) + ( radiusY ) * cosf( RADIAN( theta )))


/*---------------------------------------------------------------
	萔`
---------------------------------------------------------------*/

#define NUM_VERTEX  ( 4 )								// 1`Ŏgp钸_
#define NUM_POLYGON ( 2 )								// `悷|S

#define TEXTURE_NAME "data/TEXTURE/background.jpg"		// eNX`pX

/*----------------------------------------------------------------
	X^eBbNoϐ̏
----------------------------------------------------------------*/

CObject*              CObject::pObj[OBJECT_MAX] = {};
vector< DETABASE >    CObject::ID;
int                   CObject::counter = 0;
LPDIRECT3DDEVICE9     CObject::pDevice = nullptr;




// IuWFNg̃RXgN^
CObject::CObject( )
{

	// foCX̎擾
	if( !pDevice ){
	
		pDevice = GetDevice( );
	}

	// 
	for( int index = 0; index < OBJECT_MAX; index++ ){
		
		if( pObj[ index ] == NULL ){
			
			pObj[ index ] = this;
			myNumber      = index;
			//DETABASE data = { "NoName", index };
			//ID.push_back( data );
			counter++;
			break;
		}
	}

	// IuWFNg̕ϐ
	D3DXMatrixIdentity( &worldMtx );
	pos = D3DXVECTOR3( 0, 0, 0 );
	rot = D3DXVECTOR3( 0, 0, 0 );

}

// IuWFNg̃fXgN^
CObject::~CObject( )
{

	// Ȃ

}

// IuWFNg̏
void CObject::Init( void )
{

	// Ȃ

}

// IuWFNg̏I
void CObject::Uninit( void )
{

	// Ȃ
	
}

// IuWFNg̍XV
void CObject::Update( void )
{

	// Ȃ

}

// IuWFNg̕`
void CObject::Draw( void )
{
	
	// Ȃ

}

// IuWFNg̃[hsZo
D3DXMATRIX CObject::CalcObjWorldMtx( void )
{

	// [hsZo
	return worldMtx;
}

// IuWFNg̍쐬
CObject* CObject::Create( void )
{

	// foCX̎擾
	if( !pDevice ){
	
		pDevice = GetDevice( );
	}

	// IuWFNg̍쐬
	CObject* pObject;
	pObject = new CObject;


	return pObject;

}

// SXV
void CObject::UpdateAll( void )
{
	
	for( int index = 0; index < counter; index ++ ){

		if( pObj[ index ] != NULL ){
		
			pObj[ index ] ->Update( );
		}
	}

}

// S`揈
void CObject::DrawAll( void )
{

	for( int index = 0; index < counter; index ++ ){

		if( pObj[ index ] != NULL ){
		
			pObj[ index ] ->Draw( );
		}
	}

}

// SJ
void CObject::ReleaseAll( void )
{

	for( int index = 0; index < counter; index ++ ){

		if( pObj[ index ] != NULL ){
		
			pObj[ index ] ->Uninit( );
		}
	}

}

// IuWFNgANZX
CObject* CObject::GetObject( void )
{

	return pObj[0];
	
}

// IuWFNgANZX
CObject* CObject::GetObject( const char* OBJ_NAME )
{

	return pObj[0];
	
}

// ʉ
void CObject::Release( void )
{
	
	if( pObj[ myNumber ] != NULL ){

		int nID;

		// delete̍ۂID̂ŕۑ
		nID = myNumber;

		//ID.erase( ID.begin() + nID );
		delete pObj[ nID ];
		pObj[ nID ] = NULL;
		counter--;
	}

}



